Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:48 2011
FILE NAME: timefilter.f90
PROGRAM NAME: timefilter
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    67  opt  (  11): Fused array assignments. :line 67 - 68
    67  vec  (   4): Vectorized array expression.
    67  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:48 2011
FILE NAME: timefilter.f90
PROGRAM NAME: timefilter
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Module TimeFilter
     2  !
     3  ! Authors::   SUGIYAMA Ko-ichiro
     4  ! Version::   $Id: timefilter.f90,v 1.1 2011-04-26 04:08:11 sugiyama Exp $
     5  ! Tag Name::  $Name: arare5-20111010 $
     6  ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7  ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8  !
     9  !== Overview
    10  !
    11  !åλ֥ե륿. leap-frog θŬ.
    12  !
    13  !== Error Handling
    14  !
    15  !== Bugs
    16  !
    17  !== Note
    18  !
    19  !== Future Plans
    20  !
    21  !
    22  
    23  module TimeFilter
    24  
    25    !⥸塼ɤ߹
    26    use dc_types, only : DP
    27    use gridset, only: imin,    & !x β
    28      &                imax,    & !x ξ
    29      &                jmin,    & !y β
    30      &                jmax,    & !y ξ
    31      &                kmin,    & !z β
    32      &                kmax       !z ξ
    33  
    34    !ۤηػ
    35    implicit none
    36  
    37    !°
    38    private
    39  
    40    !ؿ public °
    41    public AsselinFilter
    42  
    43    !ѿ
    44    real(DP) :: tfil = 1.0d-1  !åλ֥ե륿η
    45  
    46    !ͤ save 
    47    save tfil
    48  
    49  contains
    50  
    51    subroutine AsselinFilter(VarA, VarN, VarB)
    52      !
    53      ! ֥ե륿; Asselin Υե륿
    54      !
    55  
    56      !ۤηػ
    57      implicit none
    58  
    59      !ѿ
    60      real(DP), intent(in)     :: VarA(imin:imax,jmin:jmax,kmin:kmax)
    61      real(DP), intent(inout)  :: VarN(imin:imax,jmin:jmax,kmin:kmax)
    62      real(DP), intent(in)     :: VarB(imin:imax,jmin:jmax,kmin:kmax)
    63      real(DP)                 :: Var(imin:imax,jmin:jmax,kmin:kmax)
    64  
    65  
    66      !֥ե륿
    67      Var  = VarN + tfil * ( VarB  - 2.0d0 * VarN + VarA )
     .        if (jmax + 1 - jmin .gt. 0) then                                  
     .           J1 = and(jmax + 1 - jmin,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t93 = 1, J1                                                 
     .  !CDIR       NODEP                                                       
     .              do t95 = 1, imax + 1 - imin                                 
     .                 var(var.DSC.L1+t95-1,t93-1+var.DSC.L2,t91+var.DSC.L3) =  
     .       1            varn(t21+t95-1,t93-1+t23,t91+t25) + tfil*(varb(t31+t95
     .       2            -1,t93-1+t33,t91+t35)-2.00000000000000e+000*varn(t21+ 
     .       3            t95-1,t93-1+t23,t91+t25)+vara(t11+t95-1,t93-1+t13,t91+
     .       4            t15))                                                 
     .                 varn(t21+t95-1,t93-1+t23,t91+t25) = var(var.DSC.L1+t95-1,
     .       1            t93-1+var.DSC.L2,t91+var.DSC.L3)                      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t93 = J1 + 1, jmax + 1 - jmin, 2                            
     .  !CDIR       NODEP                                                       
     .              do t95 = 1, imax + 1 - imin                                 
     .                 var(var.DSC.L1+t95-1,t93-1+var.DSC.L2,t91+var.DSC.L3) =  
     .       1            varn(t21+t95-1,t93-1+t23,t91+t25) + tfil*(varb(t31+t95
     .       2            -1,t93-1+t33,t91+t35)-2.00000000000000e+000*varn(t21+ 
     .       3            t95-1,t93-1+t23,t91+t25)+vara(t11+t95-1,t93-1+t13,t91+
     .       4            t15))                                                 
     .                 var(var.DSC.L1+t95-1,t93+var.DSC.L2,t91+var.DSC.L3) =    
     .       1            varn(t21+t95-1,t93+t23,t91+t25) + tfil*(varb(t31+t95-1
     .       2            ,t93+t33,t91+t35)-2.00000000000000e+000*varn(t21+t95-1
     .       3            ,t93+t23,t91+t25)+vara(t11+t95-1,t93+t13,t91+t15))    
     .                 varn(t21+t95-1,t93-1+t23,t91+t25) = var(var.DSC.L1+t95-1,
     .       1            t93-1+var.DSC.L2,t91+var.DSC.L3)                      
     .                 varn(t21+t95-1,t93+t23,t91+t25) = var(var.DSC.L1+t95-1,  
     .       1            t93+var.DSC.L2,t91+var.DSC.L3)                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
    68      VarN = Var
    69  
    70    end subroutine AsselinFilter
    71  
    72  end module TimeFilter
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Tue Oct 11 12:33:48 2011
FILE NAME: timefilter.f90
PROGRAM NAME: timefilter
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Module TimeFilter
     2:            !
     3:            ! Authors::   SUGIYAMA Ko-ichiro
     4:            ! Version::   $Id: timefilter.f90,v 1.1 2011-04-26 04:08:11 sugiyama Exp $
     5:            ! Tag Name::  $Name: arare5-20111010 $
     6:            ! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
     7:            ! License::   See COPYRIGHT[link:../../COPYRIGHT]
     8:            !
     9:            !== Overview
    10:            !
    11:            !åλ֥ե륿. leap-frog θŬ. 
    12:            ! 
    13:            !== Error Handling
    14:            !
    15:            !== Bugs
    16:            !
    17:            !== Note
    18:            !
    19:            !== Future Plans
    20:            !
    21:            !
    22:            
    23:            module TimeFilter
    24:            
    25:              !⥸塼ɤ߹
    26:              use dc_types, only : DP
    27:              use gridset, only: imin,    & !x β
    28:                &                imax,    & !x ξ
    29:                &                jmin,    & !y β
    30:                &                jmax,    & !y ξ
    31:                &                kmin,    & !z β
    32:                &                kmax       !z ξ
    33:            
    34:              !ۤηػ
    35:              implicit none
    36:            
    37:              !°
    38:              private
    39:            
    40:              !ؿ public °
    41:              public AsselinFilter
    42:            
    43:              !ѿ
    44:              real(DP) :: tfil = 1.0d-1  !åλ֥ե륿η
    45:            
    46:              !ͤ save 
    47:              save tfil
    48:              
    49:            contains
    50:              
    51:              subroutine AsselinFilter(VarA, VarN, VarB)
    52:                !
    53:                ! ֥ե륿; Asselin Υե륿
    54:                !
    55:            
    56:                !ۤηػ
    57:                implicit none
    58:                
    59:                !ѿ
    60:                real(DP), intent(in)     :: VarA(imin:imax,jmin:jmax,kmin:kmax)
    61:                real(DP), intent(inout)  :: VarN(imin:imax,jmin:jmax,kmin:kmax)  
    62:                real(DP), intent(in)     :: VarB(imin:imax,jmin:jmax,kmin:kmax)
    63:                real(DP)                 :: Var(imin:imax,jmin:jmax,kmin:kmax)
    64:            
    65:            
    66:                !֥ե륿
    67: **V---->       Var  = VarN + tfil * ( VarB  - 2.0d0 * VarN + VarA ) 
    68: **V----        VarN = Var
    69:                
    70:              end subroutine AsselinFilter
    71:              
    72:            end module TimeFilter
